

class Angle {

    constructor(radians) {
        this.angle = radians;
    }

    get getValue() {
        return this.angle;
    }
    get degreesValue() {
        this.angle * 180 / Math.PI;
    }
    static createFromDegrees(degrees) {
        return new Angle(degrees * Math.PI / 180);
    }

    get cos() {
        return Math.cos(this.angle);
    }

    get sin() {
        return Math.sin(this.angle);
    }

    get tan() {
        return Math.tan(this.angle);
    }

    add(a) {
        return new Angle(this.angle + a);
    }

    minus(a) {
        return new Angle(this.angle - a);
    }


    equals(a) {
        return a == this.value();
    }

    isReal() {
        // TODO
        return true;
    }

    withinRange(a, range) {
        return this.angle < a + range && this.angle > a - range;
    }

    isAcute() {
        return this.angle < Math.PI / 2;
    }
    greaterThan(a) {
        return this.angle > a;
    }

    lessThan(a) {
        return this.angle < a;
    }

    equals(a) {
        return a == this.value;
    }


    static get k2PI() {
        return k2PI;
    }
    static get ZERO() {
        return ZERO;
    }
    static get DEG_360() {
        return DEG_360;
    }
    static get DEG_30() {
        return DEG_30;
    }
    static get DEG_60() {
        return DEG_60;
    }
    static get DEG_90() {
        return DEG_90;
    }
    static get DEG_120() {
        return DEG_120;
    }
    static get DEG_180() {
        return DEG_180;
    }
    static get DEG_270() {
        return DEG_270;
    }
    static get STRAIGHT_ANGLE() {
        return STRAIGHT_ANGLE;
    }
}

module.exports = Angle;

const k2PI = Math.PI * 2.0;

/** 0 Degree Angle */
const ZERO = new Angle(0);

/** 360 Degree Angle */
const DEG_360 = new Angle(Math.PI * 2.0);

/** 180 Degree Angle */
const DEG_180 = new Angle(Math.PI)

/** Straight Angle */
const STRAIGHT_ANGLE = new Angle(Math.PI)

/** 90 Degree Angle */
const DEG_90 = new Angle(Math.PI / 2.0)

/** Right Angle */
const RIGHT_ANGLE = new Angle(Math.PI / 2.0)

/** 60 Degree Angle */
const DEG_60 = new Angle(Math.PI / 3.0)

/** 30 Degree Angle */
const DEG_30 = new Angle(Math.PI / 6.0)

/** 270 Degree Angle */
const DEG_270 = new Angle(3.0 * Math.PI / 2.0);

/** 120 Degree Angle */
const DEG_120 = new Angle(2.0 * Math.PI / 3.0);
