const Receiver = require('../receiver');

class WebReceiver extends Receiver {
    constructor() {
        super();
    }

    set wss(value) { 
        this._wss = value;
        this._listeners = {};

        this._wss.onclose = (event) => {
            console.log('Web receiver socket has closed: ', event);
        };

        this._wss.onerror = (event) => {
            console.log('Web receiver socket is on error: ', event);
        };

        this._wss.on('connection', (ws) => {

            console.log('Connecting socket');

            ws.onclose = (event) => {
                console.log('Connected socket has closed');
            };

            ws.onerror = (event) => {
                console.log('Connected socket is on error: ', event);
            };

            // Handle request
            ws.on('message', (data) => {

                let packet = JSON.parse(data);
                // Try to find the listener for the requested action
                let res = this._listeners[packet.event](packet.event, packet.data);

                packet = {
                    event: 's-' + packet.event,
                    data: res
                };

                // Acknowledge the client
                ws.send(JSON.stringify(packet));
            });
        });
    }

    on(event, callback) {
        this._listeners[event] = callback;
    }
}

module.exports = WebReceiver;
